#coding: utf-8

import os, time, json

invalidProc = ['brasero',]
printerWhiteList = ['SecuPrint-Driver', ]
printerList = None

def disableInvalidPrinters(reject_root):
	with os.popen('who') as pipe:
		outData = pipe.read()
	if len(outData) > 32:
		user = outData.split()[0]
		cmd = 'runuser -l %s -c "lpstat -a"' % user
	else:
		user = 'root'
		cmd = 'lpstat -a'
	with os.popen(cmd) as pipe:
		outData = pipe.read()
	'''
	HP-LaserJet-M3530 not accepting requests since ... -
		Rejecting Jobs
	Lenovo-SPX251 accepting requests since ...
	SecuPrint-Driver accepting requests since ...
	'''
	for outLine in outData.split('\n'):
		prn = outLine.split()
		if len(prn) < 5:
			continue
		if prn[0] in printerWhiteList:
			continue
		#print(prn[0],prn[1])
		if user == 'root':
			if prn[1] == 'accepting' and reject_root:
				print('cupsreject ' + prn[0])
				os.system('cupsreject ' + prn[0])
		else:
			if prn[1] == 'accepting': # shouldn't see this printer
				print('disable printer:[%s] for user:[%s]' % (prn[0], user))
				os.system('lpadmin -p %s -u allow:root' % prn[0])
			if prn[1] == 'not':
				print('cupsaccept ' + prn[0])
				os.system('cupsaccept ' + prn[0])
		time.sleep(0.1)

def checkNewPrinter():
	curList = os.listdir('/etc/cups/ppd')
	global printerList
	if printerList == None:
		printerList = curList
	if len(curList) == len(printerList):
		return None
	elif len(curList) < len(printerList):
		printerList = curList
		print('printer deleted')
		return None

	prnName = None
	for prn in curList:
		if prn in printerList:
			continue
		prnName = prn[:-4] # name.ppd
		print('found new printer:'+prnName)
	printerList = curList
	return prnName

def disablePort(prnName):
	'''printerConf = None
	with open('/etc/cups/printers.conf', 'r') as f:
		printerConf = f.read() # not updated yet
	iPrinter = printerConf.find('<Printer '+prnName)
	iUrl = printerConf.find('DeviceURI ', iPrinter)
	iCol = printerConf.find(':', iUrl)
	if iPrinter<0 or iCol<iUrl:
		print('printers.conf format error')
		sys.exit(0) # won't happen
	devPort = printerConf[iUrl+10: iCol]'''
	devPort = 'usb'

	fileMode = 0
	with os.popen('ls -l /usr/lib/cups/backend/'+devPort) as pipe:
		out = pipe.read() # -rwxr--r--
	for i in range(3):
		fileMode *= 10
		if out[i*3+1] == 'r':
			fileMode += 4
		if out[i*3+2] == 'w':
			fileMode += 2
		if out[i*3+3] == 'x':
			fileMode += 1
	print(devPort, fileMode)
	os.system('chmod -x /usr/lib/cups/backend/'+devPort)
	for i in range(12):
		os.system('cupsreject ' + prnName)
		os.system('lprm -P ' + prnName) # clear all jobs
		time.sleep(5)
	os.system('chmod 0%d /usr/lib/cups/backend/%s' % (fileMode, devPort))

def killInvalidProc():
	for proc in invalidProc:
		with os.popen('pidof '+proc) as pipe:
			outData = pipe.read()
		if len(outData) == 0:
			continue
		print('pkill -9 '+proc)
		os.system('pkill -9 '+proc)

def renameHost():
	with os.popen('hostname') as pipe:
		if pipe.read().startswith('A-'):
			return '' # already renamed

	with os.popen('hostname -I') as pipe:
		ipList = pipe.read().split()
	ip = ipList[0].split('.') if len(ipList) > 0 else None
	if ip == None or '127' in ip[0]: # [::127.0.0.1] no network
		return None
	newName = 'hostnamectl set-hostname A-'+ip[0]+'-'+ip[1]+'-'+ip[2]+'-'+ip[3]
	os.system(newName)
	return newName

#if __name__ == '__main__':
def startMonitorDevice():
	curPath = os.path.dirname(os.path.abspath(__file__))
	pcrPath = curPath.replace('COMMON','KLSJ').replace('DK','pcreader')
	jsonPath = curPath + '/config.json' # work in client
	if not os.path.exists(jsonPath):
		jsonPath = '/var/lib/secuprint/secu-dk.json'
	if not os.path.exists(jsonPath):
		jsonPath = pcrPath + '/secu-dk.json'

	cfg = None
	with open(jsonPath) as fp:
		cfg = json.load(fp)
	if cfg == None:
		print('not found:', jsonPath)
		return

	#if 'SBP-CDWriter' in cfg and cfg['SBP-CDWriter'] == 1: # SBP1000
	os.system(pcrPath + '/sbpsvr &')

	if 'RenameHost' in cfg and cfg['RenameHost'] == 1: # rename host to A[ip2]-[ip3]
		while renameHost() == None:
			print('renameHost ...')
			time.sleep(3)

	global printerWhiteList
	if len(cfg['PrinterWhiteList']) > 0:
		printerWhiteList.append(cfg['PrinterWhiteList'])
		print('WhitePrinter', cfg['PrinterWhiteList'])

	lTick = 0
	while True:
		if lTick % 10 == 0: # every 5 seconds
			killInvalidProc()
			if cfg['PrinterWhiteList'] != '*':
				disableInvalidPrinters(False)
			#os.system('eject /dev/sdb') #eject udisk
		#prnName = checkNewPrinter()
		#if prnName != None:
		#	disablePort(prnName)
		time.sleep(0.5)
		lTick += 1

