#!/bin/python3
#coding: utf-8

import sys, os, traceback, socket

ldir = os.path.dirname(__file__).split(os.sep)
if len(ldir) > 4 and ldir[1] == 'opt':
	ldir[4],ldir[6] = 'COMMON','DK'
else:
	ldir[-1] = 'common'
sys.path.append(os.sep.join(ldir))
sys.path.append(os.sep.join(ldir+['pylib.zip']))

import myutil
from PyQt5 import QtWidgets
from online import OnlineDlg

if __name__ == '__main__':
	app_id = 'secuprint.client'
	app = QtWidgets.QApplication(sys.argv)
	app.setApplicationName(app_id)

	curPath = os.path.abspath(__file__)
	iSlash = curPath.rfind(os.sep)
	myutil.appPath = curPath[0 : iSlash]

	qssFile = os.path.join(myutil.appPath, 'ui.qss')
	if os.path.exists(qssFile):
		with open(qssFile, 'r') as fp:
			qss = fp.read()
			myutil.uiStyle = qss.replace('_IMG', myutil.appPath.replace('\\', '/')+'/images')
	else:
		QtWidgets.QMessageBox.warning(None, '!', 'cannot read:'+qssFile)

	sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
	sock.settimeout(1)
	if 0 == sock.connect_ex(('127.0.0.1', 17002)):
		if len(sys.argv) > 2: # send sso param to running client
			param = ''
			for i in range(2, len(sys.argv)):
				param += sys.argv[i] + ' '
			sbuf = bytearray(len(param)+6)
			sbuf[0] = 0x7e
			sbuf[1] = 4
			sbuf[2] = len(sbuf) -4
			sbuf[3] = 0
			sbuf[4:] = param.encode()
			sock.sendall(sbuf)
			pass
		else:
			QtWidgets.QMessageBox.warning(None, "!", u"客户端已经在运行")
		sock.close()
		sys.exit(0)

	if os.sep == '/' and len(sys.argv) > 1 and sys.argv[1] == '-daemon':
		os.system('sh %s/secuclientdaemon.sh &' % myutil.appPath)
	app.setQuitOnLastWindowClosed(False)
	try:
		dlg = OnlineDlg()
		app.exec_()
	except Exception as e:
		print(repr(e))
		QtWidgets.QMessageBox.critical(None, '!', traceback.format_exc())
	sys.exit(0)
