#!/usr/bin/python3

import os
import sys
import time
import xml.dom.minidom
#from xml.dom.minidom import parse

# xmlFile: /full/path/a.xml, nodePath: node1/node2
def getXmlData(xmlFile, nodePath):
	node = xml.dom.minidom.parse(xmlFile).documentElement
	elemNames = nodePath.split("/")
	for nodeName in elemNames:
		node = node.getElementsByTagName(nodeName)[0]
	return node.firstChild.data

def checkStartService(svcName):
	if os.sep == "\\": #windows
		cmdQuery = "sc query " + svcName
		cmdStart = "sc start " + svcName
	else: #linux
		cmdQuery = "systemctl status " + svcName
		cmdStart = "systemctl start " + svcName
	pipeConsole = os.popen(cmdQuery)
	outData = pipeConsole.read()
	if outData.find("RUNNING") < 0 and outData.find("running") < 0:
		print(svcName +" stopped, starting...")
		os.system(cmdStart)

#print("path: "+__file__) # relative or abs path, depends on os
#print("abs-path: "+os.path.abspath(__file__))
curPath = os.path.abspath(__file__)
iSlash = curPath.rfind(os.sep); # \ on win, / on linux
iSlash = curPath.rfind(os.sep, 0, iSlash-1);
xmlPath = curPath[0 : iSlash+1] + "Config.xml"

svcList = getXmlData(xmlPath, "service").split( )
if len(svcList) == 0:
	print('no service')
	sys.exit(0)
while 1:
	for svcName in svcList:
		checkStartService(svcName)
	time.sleep(5)

