#!/bin/python3
#coding: utf-8

import sys, os, io, traceback

ldir = os.path.dirname(__file__).split(os.sep)
if len(ldir) > 4 and ldir[1] == 'opt':
	ldir[4],ldir[6] = 'COMMON','DK'
else:
	ldir[-1] = 'common'
sys.path.append(os.sep.join(ldir))
sys.path.append(os.sep.join(ldir+['pylib.zip']))

import myutil
from PyQt5 import QtCore, QtWidgets
from pcreaderwin import PCReaderWindow

if __name__ == '__main__':
	app_id = 'secuprint.pcreader'
	app = QtWidgets.QApplication(sys.argv)
	app.setApplicationName(app_id) 

	if sys.stdout.encoding.lower() != 'utf-8':
		sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding='utf-8')

	curPath = os.path.abspath(__file__)
	iSlash = curPath.rfind(os.sep)
	myutil.appPath = curPath[0 : iSlash]

	qssFile = os.path.join(myutil.appPath, 'ui.qss')
	if os.path.exists(qssFile):
		with open(qssFile, 'r') as fp:
			qss = fp.read()
			myutil.uiStyle = qss.replace('_IMG', myutil.appPath.replace('\\', '/')+'/images')
	else:
		QtWidgets.QMessageBox.warning(None, '!', 'cannot read:'+qssFile)

	qTranslator = QtCore.QTranslator()
	qTranslator.load(myutil.appPath + os.sep + "pcreaderwin_zh.qm")
	app.installTranslator(qTranslator)
	try:
		win = PCReaderWindow()
		app.exec_()
	except Exception as e:
		print(repr(e))
		QtWidgets.QMessageBox.critical(None, '!', traceback.format_exc())
	sys.exit(0)
